Last Comment Bug 156082 - Don't hide the tab bar when clicking the close box (pref for showing single tab ["Hide tab bar when only one tab is open"] is ignored)
: Don't hide the tab bar when clicking the close box (pref for showing single t...
Status: VERIFIED FIXED
: fixed-seamonkey1.1b
Product: SeaMonkey
Classification: Client Software
Component: UI Design (show other bugs)
: Trunk
: All All
: P5 normal with 20 votes (vote)
: seamonkey1.1beta
Assigned To: Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com]
:
Mentors:
: 154849 159191 168421 182000 183422 183473 183475 187871 188267 209903 220791 222109 238198 245786 304775 313416 322326 383615 (view as bug list)
Depends on: 351289
Blocks: 220213
  Show dependency treegraph
 
Reported: 2002-07-06 21:55 PDT by Jeremy M. Dolan
Modified: 2009-10-13 01:58 PDT (History)
44 users (show)
asa: blocking1.7b-
patrick.hendriks+bugzilla: blocking‑aviary1.0-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked (1.03 KB, patch)
2004-09-28 04:36 PDT, n0dalus
no flags Details | Diff | Splinter Review
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked (1.03 KB, patch)
2004-09-28 11:42 PDT, n0dalus
jag-mozilla: superreview-
Details | Diff | Splinter Review
blank last tab (1.49 KB, patch)
2006-08-12 16:22 PDT, Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com]
jag-mozilla: review+
neil: superreview+
cbiesinger: approval‑seamonkey1.1b+
Details | Diff | Splinter Review

Description Jeremy M. Dolan 2002-07-06 21:55:19 PDT
Don't hide the tab bar when clicking the close box

Bug 150099's 'fix' makes absolutely no sense and is "fundamentally
counterintuitive, producing results that cannot" possibly "be predicted or
expected by the user"

See bug 150099 comment 28
Comment 1 Jeremy M. Dolan 2002-07-06 22:11:49 PDT
Nominating for the same things the original bug had. CC'ing mpt (sorry chap),
but maybe he can properly explain why this just can't be, if it isn't obvious
enough.
Comment 2 jag (Peter Annema) 2002-07-08 10:29:21 PDT
-> UI design, cc'ing Lori.
Comment 3 Mike Kaply [:mkaply] 2002-07-14 19:19:19 PDT
Man this was a bad idea.

So I click close on my tab browser and the only way to get it back is to open a
new tab and then close that tab?

Bad idea.

The close button shouldn't even be there if I have the browser set to always
display the tab bar, or at LEAST if I click close when I have that pref set, it
should change the pref so that when I go back into preferences, I can turn it
back on.

As it is, I have no tab bar and the pref says I should. Figure that out.
Comment 4 jag (Peter Annema) 2002-07-15 00:05:06 PDT
Use View -> Show/Hide -> Tab Bar to show the tab bar again.

The pref is about auto-hiding, the close box forcibly hides the tab bar when the
auto-hide pref is off. I tried not to reuse the pref, because if you do, there's
another case where you'll get confusion, which is when you've used the close box
to hide the tab bar, open a second tab and then later close that second tab, the
tab bar will automatically hide (not what's expected), leaving you with no easy
way to get the tab bar to stay visible (other than going back to the prefs).

The problem here is that there are two models to hide the tab bar, one that
hides it automatically when there's one tab left, another where the user hides
it, and their overlap confuses people who've previously only been exposed to the
auto-hide feature.
Comment 5 Christian :Biesinger (don't email me, ping me on IRC) 2002-08-28 13:22:23 PDT
*** Bug 159191 has been marked as a duplicate of this bug. ***
Comment 6 Torben 2002-11-26 10:52:27 PST
*** Bug 182000 has been marked as a duplicate of this bug. ***
Comment 7 Torben 2002-12-04 07:28:39 PST
*** Bug 183475 has been marked as a duplicate of this bug. ***
Comment 8 Torben 2002-12-04 07:29:10 PST
*** Bug 183473 has been marked as a duplicate of this bug. ***
Comment 9 Torben 2002-12-04 07:29:11 PST
*** Bug 183422 has been marked as a duplicate of this bug. ***
Comment 10 guanxi 2002-12-09 08:18:55 PST
jag: "The problem here is that there are two models to hide the tab bar ... and
their overlap confuses people who've previously only been exposed to the
auto-hide feature."


The problem is that ordinary users lose the tab bar and never get it back.  I've
seen it on their Netscape 7 installs.

If they can't find the tab bar, then tabbed browsing effectively doesn't exist
in their browser.


"Use View -> Show/Hide -> Tab Bar"

I doubt many users will look until they find that command, two levels deep in a
menu, esp. when they don't necessarily know what this new feature does.  
Comment 11 Michael Lefevre 2002-12-17 04:07:57 PST
*** Bug 168421 has been marked as a duplicate of this bug. ***
Comment 12 Michael Lefevre 2002-12-17 04:09:58 PST
Bug 168421, which I just duped, points out that this bug occurs with ctrl+f4 as
well as a click on the close box.
Comment 13 R.K.Aa. 2003-01-06 03:02:46 PST
*** Bug 187871 has been marked as a duplicate of this bug. ***
Comment 14 R.K.Aa. 2003-01-08 19:51:47 PST
*** Bug 188267 has been marked as a duplicate of this bug. ***
Comment 15 Geoff Filippi 2003-01-16 09:01:29 PST
This is my observation of the issue:
[1.2.1 Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.2.1) Gecko/20021130] 

When you click "x" on the tab bar with one tab open, the tab bar closes but the 
page stays up. After that, any browser windows that you open don't show the tab
bar. 

I made sure that "Hide the tab bar when only one tab is open" was DEselected in
preferences. Yet when only one tab is open, the tab bar is still hidden.

The bug, I guess, is that the preferences don't reflect the actual behavior in
this case.

A more intuitive behavior might be this:
When you click "x" with only one tab open, the tab you were viewing goes away,
and a new tab "(Untitled)" is opened. That is, the tab currently created by
File->New->Navigator Tab. This would seem more consistent to me because the
other toolbars are all hidden/shown through the View menu (and not by clicking
directly on them.) If you want to actually hide the tab bar, you should do so
with the view menu.

If this doesn't seem intuitive to everyone, then perhaps a preference could be
added: 
When only one tab is open:
"x" hides the tab bar OR
"x" closes the last tab and opens a new tab
Comment 16 Jonadab the Unsightly One (Nathan Eady) 2003-01-18 06:34:03 PST
> When only one tab is open:
> "x" hides the tab bar OR
> "x" closes the last tab and opens a new tab

"x" is not the right terminology to use.  First, there are other "x" buttons
all over the place, depending on your theme.  The stop button, for example.
Second, the close-tab buttom may not be an "x" at all, depending on theme.
Additionally, Ctrl-W does the same thing (or clover-W on Mac).  Also, what
happens if both of those are checked?  Shouldn't they be mutually exclusive?
Perhaps something more along these lines:

Attempting to close the last tab
  (*) replaces the page with a blank one
  ( ) hides the tab bar
  ( ) does nothing

(I marked about:blank as default because I listed it first, but it doesn't
actually matter what the default is; people who don't change prefs don't 
use tabs, either.)

I could also live with following the pref as it stands now and only hiding
the tab bar when "Hide the tab bar when only one tab is open" is checked,
or when the user hides it under Show/Hide in the View menu.  If we go that
way, the close-tab button should be disabled when only one tab is showing,
and Classic and Modern should be fixed to have it appear disabled ("greyed
out") when [disabled=true], just like other buttons (back, forward, &c).
(Whatever Modern and Classic both do, third-party themes eventually follow.)
This really would be what I would think would be right -- but the preference
approach above would be acceptable also, and lets us get away without adding
a disabled state to the button.
Comment 17 mozilla 2003-01-19 01:43:33 PST
This is a bug, the tab bar 'x' means close, nobody can dispute that.
Ctrl-w means close tab, nobody can dispute that.

They should do the same thing, simple as that.  If we started adding 'options'
for anything that didn't work as expected, the user would be swamped and give up!

If the user doesn't want the tab bar, they can use the existing options to do so.

C'mon, there are dozens of bugs reported on the same problem, why can't someone
spend 5min fixing the 'x' to ctrl-w?

You won't even accept the bug? won't even commit to a target milestone?  20+ppl
in the CC list can't be hallucinating.
Comment 18 Simon Liddington 2003-04-01 20:12:01 PST
This is definitely a bug. Here's some behaviour which to my mind proves it. With
the hide tab bar with one tab open pref not set, try opening a new window then
click the close tab. Tab bar disappears as we know. Now close your window and
open another new one ... hey where's the tab bar!!! This is a case of the pref
being blatantly ignored.

It's also a case of consistency. Why should the button suddenly do something
different just because there is only one tab left and more than that it does
something I thought I asked to never happen. The button should either not be
shown with one tab or close the tab leaving no tabs (like word) or leave a blank
tab. Any will do, but the current behaviour is wrong!
Comment 19 Christopher Aillon (sabbatical, not receiving bugmail) 2003-05-14 05:50:37 PDT
*** Bug 205626 has been marked as a duplicate of this bug. ***
Comment 20 Jason Bassford 2003-05-14 06:01:52 PDT
Currently:

Window closes with: Ctrl-W, File -> Close Tab.
Tab bar hides with: Tab bar close (X).
Nothing (inactive): Context menu close. 

Right now, I would be much happier if everything did the same thing. 
Inconsistency sucks.  Even if every close method closed the tab bar (which I
*don't* think should be the case) I'd prefer things to what we have now.  Then,
at least, we could address every situation with one single patch.
Comment 21 Rafael Ebron (:rebron) 2003-05-20 10:23:00 PDT
adt: nsbeta1-
Comment 22 Jason Bassford 2003-10-14 11:10:34 PDT
*** Bug 222109 has been marked as a duplicate of this bug. ***
Comment 23 guanxi 2003-10-29 13:35:59 PST
*** Bug 220791 has been marked as a duplicate of this bug. ***
Comment 24 Nitin (vfwlkr) 2003-12-25 16:34:02 PST
*** Bug 209903 has been marked as a duplicate of this bug. ***
Comment 25 Nitin (vfwlkr) 2003-12-25 16:45:02 PST
reassigning bug to current owner/QA of tabbed browser component.
Comment 26 R.K.Aa. 2004-03-21 12:51:10 PST
*** Bug 238198 has been marked as a duplicate of this bug. ***
Comment 27 Prognathous 2004-06-07 18:24:47 PDT
*** Bug 245786 has been marked as a duplicate of this bug. ***
Comment 28 Rastignac 2004-06-09 23:59:31 PDT
OK. My idea is:

- When there are more than one tab, the button is [x] and close the current tab.

- When there is only one tab, the button changes to something different (let's
say [/] for example) and hide the tab bar.

I think it's good.
Comment 29 Nitin (vfwlkr) 2004-06-10 00:04:27 PDT
What about middle-click to close the last open tab?
Comment 30 Niels Basjes 2004-06-10 00:37:20 PDT
(In reply to comment #28)
> - When there is only one tab, the button changes to something different (let's
> say [/] for example) and hide the tab bar.

I disagree with this suggestion. From a usability standpoint I think it is
confusing for the user when a menu item or button at a specific location changes
function. That is why menu and dialog items that are not applicable are greyed
out instead of removed.

My suggestion would therefor be:
- many tabs: [X] closes the currently shown tab.
- 1 tab: [X] closes the currently shown tab. I feel that logic dictates that the
 window should be closed as well. Hiding the tab bar defies logic.
Comment 31 Ariel Arjona 2004-06-10 12:25:32 PDT
I agree with comment #30. 
I think that the best option is to close que whole window, as it happens if one
uses the keyboard shortcut (Ctrl W). The second best would be to simply disable
the button when there's only one tab open.
Comment 32 dolphinling 2004-06-10 18:17:24 PDT
A while ago on the newsgroups this subject was discussed. IIRC (big if) the
verdict was about equally split between closes the tab, leaves no tabs open,
closes the tab, opens a new tab with a blank page, and closes the window.

I see things as follows: when I click the close tab button, I am expecting the
tab to close /and/ I am expecting the tab behind it to be revealed. That's what
happens every other time. This is a slightly special case, since there is no tab
behind it to be revealed; therefore, logic dictates it should be closed and
nothing else revealed, but usability dictates that another tab should be opened
since having no tabs open is useless and since in every other case I am
expecting another tab to be there. 

I definitely do not expect the window to be closed. If I wanted the window to
close, I would use the button the OS provides. This is easier (it's nearly
always in a corner of the screen if the window is maximized or in an area of
higher contrast and therfore easier to pick out if the window is not) and is the
standard way of doing things. Also, if the tab button closes the window, then
/every single time/ I want to close a tab, I have to think "Will this close the
whole program?" since I don't want the whole program closed, I just want that
tab closed. As minor as that is to check, doing it every single time will get
quite annoying. 
Comment 34 Sergei Haller 2004-06-11 07:27:57 PDT
(In reply to comment #31)
> I agree with comment #30. 
> I think that the best option is to close que whole window, as it happens if one
> uses the keyboard shortcut (Ctrl W). The second best would be to simply disable
> the button when there's only one tab open.

I fully agree. where "disable the button" means "gray out the button"
Comment 35 guanxi 2004-06-11 09:11:40 PDT
If you want to debate the merits of bugs, including advocating one resolution or
another, please use a forum such as newsgroups or mozillazine forums.

Bugzilla isn't the place for it.
Comment 36 Nitin (vfwlkr) 2004-07-27 18:05:24 PDT
Just an fyi for those who are waiting for this (even more so because this bug
isnt assigned yet), there is an extension that fixes this bug:
http://update.mozilla.org/extensions/moreinfo.php?id=175&vid=334&category=
Comment 37 Jason Bassford 2004-07-27 20:27:20 PDT
Unfortunately, that XPI doesn't install for me.  I go to install it, and I'm
told "install script not found" - whatever that means...  (7/23-07 under XP.)

I do like the fact that somebody's working on an XPI, however.  If I'm not
mistaken, it makes it fairly simple to convert it into an actual patch.
Comment 38 Patrick 2004-07-28 02:41:41 PDT
fmannino: why do you remove the MINUS flag on the blocking-aviary1.0? The
decision was made by the appropriate person and since his decision on July 3, no
additional work has been done on this bug?

Setting the minus flag back again. If you DO want Blake to reconsider, than add
some comments as to why you re-request a blocking flag.
Comment 39 Brodie 2004-07-29 02:55:22 PDT
Clicking that button is actually closing the tab, but the semantics behind it is
more about stopping viewing the currently displayed page.

When a user clicks that button they are most likely meaning, "I'm done with this
page. I don't want to view it anymore. Get rid of it." 

Therefore behaviour should be:
2+ tabs = stop displaying the current page 
  (close the tab, show the next tab in order)
1 tab = stop displaying the current page 
  (replace the current page with about:blank)

The button should not ever be overloaded with behaviour to remove the tab bar.
The correct place to determine if the tab bar is shown or not is a menu and/or
preferences screen.

If the tab close button is going to be disabled at any time, it should only be
when there is only 1 tab left, AND that tab is displaying about:blank. Users
WANT to be able to stop viewing that last page.
Comment 40 Daniel Clemente 2004-07-29 03:32:42 PDT
Comment 39: that seems a good solution.
 Other proposed solutions do other things than closing the page, or create
different functionalities for the same button. Also, this does not modify the
visibility of the tab bar.
 Can anyone think of a better one?
Comment 41 Sergei Haller 2004-07-29 03:57:02 PDT
I fully agree to comment #39 where

> 2+ tabs = stop displaying the current page 
>   (close the tab, show the next tab in order)

"the next tab in order" should be "in chronological order",
i.e., in order they wer viewed last.
Comment 42 Daniel Clemente 2004-07-29 04:24:00 PDT
Comment 41: that would be another bug which requires a lot of discussion.
Something like "go to the last viewed tab when current tab is closed".
Comment 43 Sergei Haller 2004-07-29 06:40:42 PDT
(In reply to comment #42)
> Comment 41: that would be another bug which requires a lot of discussion.
> Something like "go to the last viewed tab when current tab is closed".

you're right: this is bug 105722
Comment 44 Nitin (vfwlkr) 2004-09-27 01:13:32 PDT
same bug for firefox (now fixed): bug 248987
Comment 45 Tracy Walker [:tracy] 2004-09-27 10:53:31 PDT
this is fixed in bug 248987. 
the decision there was to about:blank the last tab if the user clicked the [x]
to close the last tab. 

marking this a dupe since the fix was attached there.

*** This bug has been marked as a duplicate of 248987 ***
Comment 46 Jason Bassford 2004-09-27 11:03:39 PDT
Bug 248987 is Firefox specific and has nothing to do with the Mozilla browser -
which this bug is filed again.

Reopening.
Comment 47 n0dalus 2004-09-28 04:36:38 PDT
Created attachment 160327 [details] [diff] [review]
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked

This is the approved patch I wrote for Firefox in bug 248987, modified for
Mozilla.
I don't have Mozilla to check that it works, but I dont see why it wouldn't.
Comment 48 Daniel Clemente 2004-09-28 11:38:40 PDT
> this.loadURI("about.blank");

It's about:blank
Comment 49 n0dalus 2004-09-28 11:42:10 PDT
Created attachment 160372 [details] [diff] [review]
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked

Sorry about the typo.
Comment 50 Mano (::mano, needinfo? for any questions; not reading general bugmail) 2004-11-29 00:49:05 PST
Comment on attachment 160372 [details] [diff] [review]
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked

requesting r/sr for your patch.
Comment 51 jag (Peter Annema) 2004-12-01 02:31:45 PST
Comment on attachment 160372 [details] [diff] [review]
Blanks last tab instead of hiding the Tab Bar if "Hide Tab Bar" option is unticked

Erh, you shouldn't have to check the autohide pref, if that is set to true,
with only one tab left the bar is hidden and there's no close box to click.
This reveals the dead code resulting from this patch, namely the code that
would force the tab bar to hide. And with that gone the rest of the code
dealing with browser.tabs.forceHide can also be removed / amended.

That said, let me think about the desired effect of this patch. I'll get back
to you on this.
Comment 52 neil@parkwaycc.co.uk 2004-12-01 05:33:45 PST
(In reply to comment #51)
>This reveals the dead code resulting from this patch, namely the code that
>would force the tab bar to hide. And with that gone the rest of the code
>dealing with browser.tabs.forceHide can also be removed / amended.
Does that include View Show/Hide Tab Bar?
Comment 53 Brodie 2004-12-03 07:42:38 PST
As far as I can see, this patch should be as follows.

var l = this.mTabContainer.childNodes.length;
if (l == 1) {
  if (this.mPrefs.getBoolPref("browser.tabs.autoHide")) {
    // this should only ever happen if the pref was changed while 
    // there was only a single tab displayed.
    this.setStripVisibilityTo(false);
  } else {
    // blank the last tab
    //TODO: remove tab history
    this.loadURI("about:blank");
  }
  return;
}


This will hide the tab-bar if autohide is true, and just blank it otherwise. We
don't want to force autohide to true at any time.
Comment 54 OstGote! 2005-08-16 15:33:17 PDT
*** Bug 304775 has been marked as a duplicate of this bug. ***
Comment 55 Nick_Jenkins 2005-08-18 19:32:04 PDT
Cross-reference to code shown in bug 236721 comment 21.

Notes:
* You always want to do loadURI("about:blank") if there is only one tab left
open. How the user has the tab-hiding set up is simply irrelevant to this, and
the current code gets this wrong (i.e. if you only have one tab left open, and
you don't have autohide on, then currently it won't close the current tab, which
is simply wrong).
* You always want to purge the session history too (see code at above cross
reference for how to do this).
* Brodie may well be correct about not setting the forceHide preference. I
haven't looked into this, and simply rearranged the existing code when it came
to this. So perhaps the 'setBoolPref("browser.tabs.forceHide", true)' line
should be deleted.
Comment 56 Jason Bassford 2005-08-18 20:03:22 PDT
See my original comment 20.  Having about:blank when clicking on the last tab
replaces one set of inconsistent results with yet another, making the overall
situation no better than before.  If that is the final solution, then should a
further bug be filed so that Ctrl-W gives you about:blank also?  (Although, I do
note that you can now use the context menu on the last tab to get the same
results as the tab close button - it's no longer greyed out.  I'm not sure when
that behaviour changed, but it's a step in the right direction of consistency.)
Comment 57 Nitin (vfwlkr) 2005-09-10 01:18:25 PDT
Changing module to mozilla application suite, since firefox already has a fix
(via bug 248987)
Comment 58 Mario 2005-10-23 09:59:36 PDT
*** Bug 313416 has been marked as a duplicate of this bug. ***
Comment 59 Peter Weilbacher 2006-01-04 08:19:35 PST
*** Bug 322326 has been marked as a duplicate of this bug. ***
Comment 60 Andrew Schultz 2006-02-08 19:03:46 PST
*** Bug 326395 has been marked as a duplicate of this bug. ***
Comment 61 tech 2006-02-08 23:52:55 PST
as bug #326395 as been marked a duplicate of this one which is more than three years old, I re-post its decription here as it doesn't seems to me that it's the same.

submited bug #326395 Opened: 2006-02-08 04:29

User-Agent:       Mozilla/5.0 (Windows; U; Win98; fr-FR; rv:1.8.0.1)
Gecko/20060130 SeaMonkey/1.0
Build Identifier: Mozilla/5.0 (Windows; U; Win98; fr-FR; rv:1.8.0.1)
Gecko/20060130 SeaMonkey/1.0

on the last release of seamonkey I installed, it's impossible to close the
first tab even when other tabs are opened.
When it's the only tab this action hides the tab bar


Reproducible: Always

Steps to Reproduce:
1.a web page
2.open another page in the second tab
3. try to close the first tab

Comment 62 tech 2006-02-09 23:39:57 PST
I've just tried with a new profile and all is working now, even other problems on bugs I've submited are gone, I'm going to reinstall one by one the extensions I have in my profile to try to identify the problematic one

> as bug #326395 as been marked a duplicate of this one which is more than three
> years old, I re-post its decription here as it doesn't seems to me that it's
> the same.
> 
> submited bug #326395 Opened: 2006-02-08 04:29
> 
> User-Agent:       Mozilla/5.0 (Windows; U; Win98; fr-FR; rv:1.8.0.1)
> Gecko/20060130 SeaMonkey/1.0
> Build Identifier: Mozilla/5.0 (Windows; U; Win98; fr-FR; rv:1.8.0.1)
> Gecko/20060130 SeaMonkey/1.0
> 
> on the last release of seamonkey I installed, it's impossible to close the
> first tab even when other tabs are opened.
> When it's the only tab this action hides the tab bar
> 
> 
> Reproducible: Always
> 
> Steps to Reproduce:
> 1.a web page
> 2.open another page in the second tab
> 3. try to close the first tab
> 

Comment 63 jan honsberg 2006-02-19 03:22:30 PST
maybe Bug 154849 is an duplicate?
Comment 64 OstGote! 2006-02-19 04:57:12 PST
*** Bug 154849 has been marked as a duplicate of this bug. ***
Comment 65 OstGote! 2006-02-19 04:57:14 PST
*** Bug 322326 has been marked as a duplicate of this bug. ***
Comment 66 Andrew Schultz 2006-02-19 09:39:41 PST
tabbed browser, no?
Comment 67 Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com] 2006-03-08 08:40:06 PST
Taking... this is low priority for me so feel free to swipe the bug and fix it yourself :).
Comment 68 Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com] 2006-08-12 16:22:33 PDT
Created attachment 233414 [details] [diff] [review]
blank last tab

Same as the Firefox implementation.
Comment 69 neil@parkwaycc.co.uk 2006-08-16 07:42:01 PDT
Comment on attachment 233414 [details] [diff] [review]
blank last tab

This will cause me dataloss, because I'm used to X hiding the tab bar...

>             var l = this.mTabs.length;
>-            if (l == 1) {
>-              // hide the tab bar
>-              this.mPrefs.setBoolPref("browser.tabs.forceHide", true);
>-              this.mStrip.collapsed = true;
>-              return;
>-            }
Move the var l to where you use it. sr=me with this fixed.
Comment 70 Bruno 'Aqualon' Escherl 2006-08-17 11:38:20 PDT
The new behaviour is inconsistent to the behaviour of Ctrl+W. If you press Ctrl+W on the last tab and browser.tabs.autoHide is set to true, the browser window gets closed and I expect the same from the close box.
Comment 71 Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com] 2006-08-20 19:15:16 PDT
(In reply to comment #70)
> The new behaviour is inconsistent to the behaviour of Ctrl+W. If you press
> Ctrl+W on the last tab and browser.tabs.autoHide is set to true, the browser
> window gets closed and I expect the same from the close box.
> 

Hmmm... Firefox doesn't let you quit with Ctrl+W.  Jag?  Neil?  Do you think we should make ^w match the behavior of clicking the "X" like Firefox?
Comment 72 Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com] 2006-08-20 19:16:58 PDT
(In reply to comment #71)
> (In reply to comment #70)
> > The new behaviour is inconsistent to the behaviour of Ctrl+W. If you press
> > Ctrl+W on the last tab and browser.tabs.autoHide is set to true, the browser
> > window gets closed and I expect the same from the close box.
> > 
> 
> Hmmm... Firefox doesn't let you quit with Ctrl+W.  Jag?  Neil?  Do you think we
> should make ^w match the behavior of clicking the "X" like Firefox?

And should it be based on the pref? (i.e. should ctrl+w close the browser if you choose to hide the tab bar?)
Comment 73 neil@parkwaycc.co.uk 2006-08-21 01:03:07 PDT
^W should always close the window if only one tab is left.
Comment 74 Chris Thomas (CTho) [formerly cst@andrew.cmu.edu cst@yecc.com] 2006-08-25 15:56:27 PDT
Fixed on trunk.
Comment 75 Christian :Biesinger (don't email me, ping me on IRC) 2006-08-31 20:50:34 PDT
Comment on attachment 233414 [details] [diff] [review]
blank last tab

changing to 1.1b as alpha was released
Comment 76 Serge Gautherie (:sgautherie) 2006-09-05 05:22:31 PDT
(In reply to comment #71)
> Hmmm... Firefox doesn't let you quit with Ctrl+W.  Jag?  Neil?  Do you think we
> should make ^w match the behavior of clicking the "X" like Firefox?

On single tab, with tab bar shown,
more than being inconsistent with FireFox (which might be our choice.?!.),

(In reply to comment #73)
> ^W should always close the window if only one tab is left.

SeaMonkey has an issue in the File menu:
it reads "Close Tab / Ctrl+W" and "Close Window / Ctrl+Shift+W";
but, while the tab bar "X" closes the tab,
Ctrl-W or its menu item closes the window :-(

I believe the FireFox behaviour (== do what the menu says) is what we want too on this point !?
Comment 77 neil@parkwaycc.co.uk 2006-09-05 05:38:59 PDT
(In reply to comment #76)
>SeaMonkey has an issue in the File menu:
>it reads "Close Tab / Ctrl+W" and "Close Window / Ctrl+Shift+W";
>but, while the tab bar "X" closes the tab,
>Ctrl-W or its menu item closes the window :-(
Actually SeaMonkey always used to do this when the tabbar was visible...
I'd prefer (in a separate bug) to make the menuitems track the actions.
Comment 78 Serge Gautherie (:sgautherie) 2006-09-05 08:49:45 PDT
I filed bug 351428 about comment 77 (and comment 72).
Comment 79 Benoît 2006-09-05 09:00:15 PDT
Wouldn't it be more logical to grey out the "Close Tab" option and not react on Ctrl+W when there is only one tab without tab bar? It doesn't seem right that closing the last tab should close the entire window, there's another option for that.
Comment 80 neil@parkwaycc.co.uk 2006-09-05 09:11:39 PDT
Ctrl+W closes the window everywhere else. It was only changed for tabbrowser because it was thought more useful for people using tabs instead of windows.
Comment 81 Mano (::mano, needinfo? for any questions; not reading general bugmail) 2006-09-05 09:25:13 PDT
Not in win32 MDI windows IIRC (Now, do we consider tabbrowser windows pseudo-MDI?). Also, and again IIRC (and FWIW ;)) this was changed in IE7 and NS8.
Comment 82 neil@parkwaycc.co.uk 2006-09-05 09:37:01 PDT
We have two categories of users. Some never use tabs and never will. For them, we have to make Ctrl+W close the window like it does (or should do, at least) everywhere else *in SeaMonkey* while for those people who have migrated from windows to tabs we need Ctrl+W to close the current tab instead.
Comment 83 Mano (::mano, needinfo? for any questions; not reading general bugmail) 2006-09-05 09:43:17 PDT
In Fx, Accel+W closes the window unless "Always show the tab bar" is ticked, in which case we destroy-and-create the first tab like the patch here does.
Comment 84 neil@parkwaycc.co.uk 2006-09-05 09:48:51 PDT
I don't think that would be right. What I could live with is that pressing Ctrl+W would close the window if the tab bar is hidden (in SeaMonkey there are three reasons that this could be the case.)
Comment 85 Mano (::mano, needinfo? for any questions; not reading general bugmail) 2006-09-05 09:59:34 PDT
yeah, ugh, we do close popup windows on Accel+W regardless of the pref.
Comment 86 neil@parkwaycc.co.uk 2006-09-12 02:46:29 PDT
I guess the "Close Tab" in the tab context menu should always be enabled?
Comment 87 Worcester12345 2006-10-18 17:09:18 PDT
(In reply to comment #86)
> I guess the "Close Tab" in the tab context menu should always be enabled?
> 

Please!
Comment 88 Wayne Mery (:wsmwk, NI for questions) 2007-06-12 09:59:03 PDT
*** Bug 322326 has been marked as a duplicate of this bug. ***
Comment 89 Emerson Seiti Takahashi 2007-06-16 21:58:42 PDT
*** Bug 383615 has been marked as a duplicate of this bug. ***

Note You need to log in before you can comment on or make changes to this bug.